// -------------------------------------------------------------------------------
//
//    This is a Template used as a guideline to build your own Robot. 
//    Please use the “Feedback” tab to provide us with your suggestions about cAlgo’s API.
//
// -------------------------------------------------------------------------------

using System;
using cAlgo.API;
using cAlgo.API.Indicators;

namespace cAlgo.Robots
{
    [Robot]
    public class NewRobot : Robot
    {
    
        [Parameter("Vol", DefaultValue = 10000)]
        public int Vol { get; set; }
        
        [Parameter("SL", DefaultValue = 200)]
        public int SL { get; set; }
        
        [Parameter("TP", DefaultValue = 200)]
        public int TP { get; set; }
        
        [Parameter("Dev", DefaultValue = 200)]
        public int Dev { get; set; }
        
        [Parameter("N", DefaultValue = 5)]
        public int N { get; set; }
        
        private Position position1,pos1;
        
        protected override void OnStart()
        {
        Print("Welcome to the world of infinite financial possibilities!");   
        
        double Bid=Symbol.Bid;
        double Ask=Symbol.Ask;
        double Point=Symbol.PointSize;
            
            for(int i = 1; i <= N; i++)
            Trade.CreateBuyStopOrder(Symbol, Vol, Ask+Dev*i*Point, 0, 0);
            
            for(int i = 1; i <= N; i++)
            Trade.CreateSellStopOrder(Symbol, Vol, Bid-Dev*i*Point, 0, 0);
        }
        
         protected override void OnPositionOpened(Position openedPosition)
        {
            position1 = openedPosition;
            
            if (position1.TradeType == TradeType.Buy)
            {
            Trade.CreateBuyStopOrder(Symbol, Vol, position1.EntryPrice+Dev*N*Symbol.PointSize, 0, 0);
            Trade.ModifyPosition(openedPosition, position1.EntryPrice-SL*Symbol.PointSize, position1.EntryPrice+TP*Symbol.PointSize);
            Print("StopLoss and TakeProfit were successfully established");
            }
            
            if (position1.TradeType == TradeType.Sell)
            {
            Trade.CreateSellStopOrder(Symbol, Vol, position1.EntryPrice-Dev*N*Symbol.PointSize, 0, 0);
            Trade.ModifyPosition(openedPosition, position1.EntryPrice+SL*Symbol.PointSize, position1.EntryPrice-TP*Symbol.PointSize);
            Print("StopLoss and TakeProfit were successfully established");
            }
        }

		protected override void OnPositionClosed(Position pos)
         {
          pos1=pos;
         
         if(pos1.TradeType== TradeType.Buy)
         {
         if (pos1.GrossProfit>0)
         Trade.CreateSellStopOrder(Symbol, Vol, pos1.EntryPrice, 0, 0);
         
         if (pos1.GrossProfit<0)
         Trade.CreateBuyStopOrder(Symbol, Vol, pos1.EntryPrice, 0, 0);
         }
         
         if(pos1.TradeType== TradeType.Sell)
         {
         if (pos1.GrossProfit>0)
         Trade.CreateBuyStopOrder(Symbol, Vol, pos1.EntryPrice, 0, 0);
         
         if (pos1.GrossProfit<0)
         Trade.CreateSellStopOrder(Symbol, Vol, pos1.EntryPrice, 0, 0);
         }
         }

        protected override void OnStop()
        {
          Print("Successful day!");   
        }
    }
}